---
title: block
slug: Web/JavaScript/Reference/Statements/block
tags:
  - JavaScript
  - Language feature
  - Reference
  - Statement
---
<div>{{jsSidebar("Statements")}}</div>

<p>A <strong>block statement</strong> (or <strong>compound statement</strong> in other languages) is used to group zero or more statements. The block is delimited by a pair of braces ("curly brackets") and may optionally be {{jsxref("Statements/label", "labelled", "", 1)}}:</p>

<div>{{EmbedInteractiveExample("pages/js/statement-block.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<h3 id="Block_Statement">Block Statement</h3>

<pre class="syntaxbox">{
  <em>StatementList</em>
}
</pre>

<h3 id="Labelled_Block_Statement">Labelled Block Statement</h3>

<pre class="syntaxbox"><em>LabelIdentifier</em>: {
  <em>StatementList</em>
}
</pre>

<dl>
 <dt><code>StatementList</code></dt>
 <dd>Statements grouped within the block statement.</dd>
 <dt><code>LabelIdentifier</code></dt>
 <dd>An optional {{jsxref("Statements/label", "label", "", 1)}} for visual identification or as a target for {{jsxref("Statements/break", "break")}}.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The block statement is often called <strong>compound statement</strong> in other languages. It allows you to use multiple statements where JavaScript expects only one statement. Combining statements into blocks is a common practice in JavaScript. The opposite behavior is possible using an <a href="/en-US/docs/Web/JavaScript/Reference/Statements/Empty">empty statement</a>, where you provide no statement, although one is required.</p>

<p>Blocks are commonly used in association with {{jsxref("Statements/if...else", "if...else")}} and {{jsxref("Statements/for", "for")}} statements.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Block_scoping_rules_with_var_or_function_declaration_in_non-strict_mode">Block scoping rules with var or function declaration in non-strict mode</h3>

<p>Variables declared with <code>var</code> or created by <a href="/en-US/docs/Web/JavaScript/Reference/Statements/function">function declarations</a> in non-strict mode <strong>do not</strong> have block scope. Variables introduced within a block are scoped to the containing function or script, and the effects of setting them persist beyond the block itself. In other words, block statements do not introduce a scope. For example:</p>

<pre class="brush: js example-bad">var x = 1;
{
  var x = 2;
}
console.log(x); // logs 2
</pre>

<p>This logs 2 because the <code>var x</code> statement within the block is in the same scope as the <code>var x</code> statement before the block.</p>

<p>In non-strict code, function declarations inside blocks behave strangely. Do not use them.</p>

<h3 id="Block_scoping_rules_with_let_const_or_function_declaration_in_strict_mode">Block scoping rules with let, const or function declaration in strict mode</h3>

<p>By contrast, identifiers declared with {{jsxref("Statements/let", "let")}} and {{jsxref("Statements/const", "const")}} <strong>do have </strong>block scope:</p>

<pre class="brush: js">let x = 1;
{
  let x = 2;
}
console.log(x); // logs 1</pre>

<p>The <code>x = 2</code> is limited in scope to the block in which it was defined.</p>

<p>The same is true of <code>const</code>:</p>

<pre class="brush: js">const c = 1;
{
  const c = 2;
}
console.log(c); // logs 1 and does not throw SyntaxError...</pre>

<p>Note that the block-scoped <code>const c = 2</code> <em>does not</em> throw a <code>SyntaxError: Identifier 'c' has already been declared</code> because it can be declared uniquely within the block.</p>

<p>In <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a>, starting with ES2015, functions inside blocks are scoped to that block. Prior to ES2015, block-level functions were forbidden in strict mode.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-block', 'Block statement')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.block")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/while", "while")}}</li>
 <li>{{jsxref("Statements/if...else", "if...else")}}</li>
 <li>{{jsxref("Statements/let", "let")}}</li>
</ul>
